package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineReverseOrder struct {
	api.Api
}

// GetPage 获取反单下单列表列表
// @Summary 获取反单下单列表列表
// @Description 获取反单下单列表列表
// @Tags 反单下单列表
// @Param orderSn query string false "订单号"
// @Param orderId query string false "币安订单号"
// @Param followOrderSn query string false "跟随币安订单号"
// @Param orderType query int false "订单类型 0-主单 1-止损单 2-加仓 3-减仓"
// @Param positionSide query string false "持仓方向 LONG-多 SHORT-空"
// @Param side query string false "买卖方向 SELL-卖 BUY-买"
// @Param status query int false "状态 1-待下单 2-已下单 3-已成交 4-已平仓 5-已止损"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineReverseOrder}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-reverse-order [get]
// @Security Bearer
func (e LineReverseOrder) GetPage(c *gin.Context) {
    req := dto.LineReverseOrderGetPageReq{}
    s := service.LineReverseOrder{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineReverseOrder, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取反单下单列表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取反单下单列表
// @Summary 获取反单下单列表
// @Description 获取反单下单列表
// @Tags 反单下单列表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineReverseOrder} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-reverse-order/{id} [get]
// @Security Bearer
func (e LineReverseOrder) Get(c *gin.Context) {
	req := dto.LineReverseOrderGetReq{}
	s := service.LineReverseOrder{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineReverseOrder

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取反单下单列表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建反单下单列表
// @Summary 创建反单下单列表
// @Description 创建反单下单列表
// @Tags 反单下单列表
// @Accept application/json
// @Product application/json
// @Param data body dto.LineReverseOrderInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-reverse-order [post]
// @Security Bearer
func (e LineReverseOrder) Insert(c *gin.Context) {
    req := dto.LineReverseOrderInsertReq{}
    s := service.LineReverseOrder{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建反单下单列表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改反单下单列表
// @Summary 修改反单下单列表
// @Description 修改反单下单列表
// @Tags 反单下单列表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineReverseOrderUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-reverse-order/{id} [put]
// @Security Bearer
func (e LineReverseOrder) Update(c *gin.Context) {
    req := dto.LineReverseOrderUpdateReq{}
    s := service.LineReverseOrder{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改反单下单列表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除反单下单列表
// @Summary 删除反单下单列表
// @Description 删除反单下单列表
// @Tags 反单下单列表
// @Param data body dto.LineReverseOrderDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-reverse-order [delete]
// @Security Bearer
func (e LineReverseOrder) Delete(c *gin.Context) {
    s := service.LineReverseOrder{}
    req := dto.LineReverseOrderDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除反单下单列表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
